#ifndef __DEFS_H__
#define __DEFS_H__

typedef unsigned short UINT16;
typedef unsigned short *PUINT16;
typedef unsigned int UINT32;
typedef unsigned int *PUINT32;
typedef unsigned long long UINT64;
typedef unsigned long long *PUINT64;
typedef void VOID;
typedef void *PVOID;
typedef char CHAR;
typedef char *PCHAR;

#define B_Flag	0x80000000
#define EM_Flag	0x40000000
#define I_Flag	0x20000000
#define S_Flag	0x10000000
#define TT_Flag	0x08000000
#define	UNDERLINE_FLAG_MASK	0x07000000
#define U1_Flag	0x04000000
#define U2_Flag	0x02000000
#define U3_Flag	0x01000000

#define	SIZE_FLAG_MASK	0x00FFC000
#define S0_Flag 0x00800000
#define S1_Flag 0x00400000
#define S2_Flag 0x00200000
#define S3_Flag 0x00100000
#define S4_Flag 0x00080000
#define S5_Flag 0x00040000
#define S6_Flag 0x00020000
#define S7_Flag 0x00010000
#define S8_Flag 0x00008000
#define S9_Flag 0x00004000

#define	COLOR_FLAG_MASK	0x00003FC0
#define Cr_Flag 0x00002000
#define Cg_Flag 0x00001000
#define Cb_Flag 0x00000800
#define Cc_Flag 0x00000400
#define Cm_Flag 0x00000200
#define Cy_Flag 0x00000100
#define Ck_Flag 0x00000080
#define Cw_Flag 0x00000040

#define AllWhiteSpaceFlag	0x00000001
#define ForceEMOff		0x00000002
#define	ForceEMSet		0x00000004
#define	PLAdded			0x00000008
#define	PLRemoved		0x00000010

#define WHITE_SPACE_EFFECT_MASK	(TT_Flag|UNDERLINE_FLAG_MASK|COLOR_FLAG_MASK|SIZE_FLAG_MASK)
#define WHITE_SPACE_EFFECT_MASK_WITHOUT_COLOR	(TT_Flag|SIZE_FLAG_MASK)

typedef struct _list_entry_struct_ {
	UINT32 state;
	UINT32 flags;
	UINT32 current;
	UINT32 max;
	PCHAR  doc;	
	struct _list_entry_struct_ *next;
	struct _list_entry_struct_ *prev;
} LIST_ENTRY, *PLIST_ENTRY;

typedef struct _list_struct_ {
	UINT32 count;
	PLIST_ENTRY first;
	PLIST_ENTRY last;
} LIST, *PLIST;

typedef struct _string_table_ {
	UINT32 Key;
	PCHAR  String;
} STRING_TABLE;

#endif  // __DEFS_H__
