
#include <stdio.h>

#include "llist.h"

typedef struct action
{
	char	onstring[6];	
	char	offstring[6];	
	int		pushable;
} action;

action actions[] = {
{	"<B>",	"</B>",		1	},
{	"<EM>",	"</EM>",	1	},
{	"<I>",	"</I>",		1	},
{	"<PL>",	"</PL>",	1	},
{	"<S>",	"</S>",		1	},
{	"<TT>",	"</TT>",	1	},
{	"<U>",	"</U>",		1	},
{	"<0>",	"</0>",		1	},
{	"<1>",	"</1>",		1	},
{	"<2>",	"</2>",		1	},
{	"<3>",	"</3>",		1	},
{	"<4>",	"</4>",		1	},
{	"<5>",	"</5>",		1	},
{	"<6>",	"</6>",		1	},
{	"<7>",	"</7>",		1	},
{	"<8>",	"</8>",		1	},
{	"<9>",	"</9>",		1	},
{	"<r>",	"</r>",		1	},
{	"<g>",	"</g>",		1	},
{	"<b>",	"</b>",		1	},
{	"<c>",	"</c>",		1	},
{	"<m>",	"</m>",		1	},
{	"<y>",	"</y>",		1	},
{	"<k>",	"</k>",		1	},
{	"<w>",	"</w>",		1	},
{	"\n",	"",			0	},
{	"\r",	"",			0	},
{	" ",	"",			0	},
{	"	",	"",			0	},
{	"\n",	"",			0	},
{	"\r",	"",			0	},
{	" ",	"",			0	},
{	"	",	"",			0	},
{	"\n",	"",			0	},
{	"\r",	"",			0	},
{	" ",	"",			0	},
{	"	",	"",			0	},
{	"\n",	"",			0	},
{	"\r",	"",			0	},
{	" ",	"",			0	},
{	"	",	"",			0	},
{	"\n",	"",			0	},
{	"\r",	"",			0	},
{	" ",	"",			0	},
{	"	",	"",			0	},
{	"A",	"",			0	},
{	"B",	"",			0	},
{	"C",	"",			0	},
{	"D",	"",			0	},
{	"E",	"",			0	},
{	"F",	"",			0	},
{	"G",	"",			0	},
{	"H",	"",			0	},
{	"I",	"",			0	},
{	"J",	"",			0	},
{	"K",	"",			0	},
{	"L",	"",			0	},
{	"M",	"",			0	},
{	"N",	"",			0	},
{	"O",	"",			0	},
{	"P",	"",			0	},
{	"Q",	"",			0	},
{	"R",	"",			0	},
{	"S",	"",			0	},
{	"T",	"",			0	},
{	"U",	"",			0	},
{	"V",	"",			0	},
{	"W",	"",			0	},
{	"X",	"",			0	},
{	"Y",	"",			0	},
{	"Z",	"",			0	}
};

int size_of_actions = sizeof(actions) / sizeof(struct action);

#define POP_IT		10000

int
random_action(void)
{
	int x = random() % (size_of_actions + 1);
	if (x >= size_of_actions)
		return POP_IT;
	return x;
}

int
main(int argc, char **argv)
{
	int filesize;
	char *filename;
	int i, x;
	PLIST head_of_stack;
	PLIST_ENTRY e;
	FILE *fp = stdout;

	if (argc != 3)
		exit(-1);

	srandom(time(NULL));
	filesize = atoi(argv[1]);
	filename = argv[2];

	fp = fopen(filename, "w+");
	rewind(fp);

	new_list(&head_of_stack);
	for (i = 0; i < filesize; i++)
	{
		x = random_action();
		
		if (x == POP_IT)		
		{
			e = get_last_entry(head_of_stack);

			if (e)
			{
				x = e->state;
				release_record(head_of_stack, e);
				fprintf(fp, "%s", actions[x].offstring);
			}
		}
		else
		{
			fprintf(fp, "%s", actions[x].onstring);
			if (actions[x].pushable)
			{
				new_record(head_of_stack, x);
			}
		}
	}

	e = get_last_entry(head_of_stack);
	while (e)
	{
		x = e->state;
		release_record(head_of_stack, e);
		fprintf(fp, "%s", actions[x].offstring);
		e = get_last_entry(head_of_stack);
	}

	fclose(fp);
}


